"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = __importDefault(require("chalk"));
class Report {
    constructor() {
        this.comparisons = [];
    }
    contribute(comparison) {
        this.comparisons.push(comparison);
    }
    display() {
        if (this.failed()) {
            console.log(chalk_1.default.bold.underline("\nMatched Rules\n"));
            this.comparisons.forEach(comparison => {
                const selector = chalk_1.default.redBright(comparison.selector);
                const matches = comparison.matchedRules.join("\n\t##");
                console.log(`selector: ${selector}\n\tmatch: ##${matches}\n`);
            });
            console.log(chalk_1.default.blue("We recommend you modify these selectors to avoid inadvertent ad blocking."));
        }
    }
    failed() {
        return this.comparisons.length > 0;
    }
}
exports.default = Report;
