"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const Constants_1 = require("./Constants");
const Check_1 = __importDefault(require("./Check"));
const Comparison_1 = __importDefault(require("./Comparison"));
const FileSystem = __importStar(require("fs"));
class Rules {
    constructor() {
        this.rules = [];
    }
    populateFromFile(filePath) {
        if (Check_1.default.isNotString(filePath)) {
            return;
        }
        // Ensure file actually exists.
        if (!FileSystem.existsSync(filePath)) {
            console.log("Does not Exist");
            return;
        }
        const easyList = FileSystem.readFileSync(filePath, "UTF-8");
        // Handle problems with reading of file.
        if (easyList === null) {
            console.log("Null List");
            return;
        }
        const easyListLines = easyList.split(Constants_1.LINES);
        // Find the relevant rules.
        easyListLines.forEach((easyListLine) => {
            if (easyListLine.match(Constants_1.DESIRED_RULE) !== null) {
                this.rules.push(easyListLine.replace(Constants_1.DESIRED_RULE, ""));
            }
        });
    }
    /**
     * @param {Rule} compareRule
     * @returns {Comparison}
     */
    compare(compareRule) {
        const matchedRules = [];
        this.rules.forEach(rule => {
            // Simple exact match.
            if (compareRule.selector === rule) {
                matchedRules.push(rule);
            }
        });
        return new Comparison_1.default({ selector: compareRule.selector, matchedRules });
    }
}
exports.default = Rules;
