"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Assert = __importStar(require("assert"));
const postcss_1 = __importDefault(require("postcss"));
const FileSystem = __importStar(require("fs"));
const index_1 = __importDefault(require("../index"));
describe("PostCSS", () => {
    // Fixtures
    const okCSS = FileSystem.readFileSync(`${__dirname}/fixtures/ok.css`, "UTF-8");
    const failCSS = FileSystem.readFileSync(`${__dirname}/fixtures/fail.css`, "UTF-8");
    // Load PostCSS with PostCSSAddBlockLint Plugin
    const postCSS = postcss_1.default([
        index_1.default({ easyList: `${__dirname}/../../data/easylist.txt` })
    ]);
    it("is silent for ok css", () => {
        Assert.ok(postCSS.process(okCSS).css === okCSS);
    });
    it("is loud for not ok css", () => {
        Assert.throws(() => {
            // Do comparison here so that we actually do the work.
            Assert.ok(postCSS.process(failCSS).css === failCSS);
        });
    });
});
